/*

Simple implemantation for dbtool. Feel free to modify. The only
commands which are really required are fut, streams and help.

When called as

	para_dbtool fut n stream_name

this program should output n lines, each of which being a complete path
of a sound file. When called as

	para_dbtool streams

it should output a list of valid stream names, separated by newlines.
When called as

	para_dbtool help
 
it should output a list of available commands. Each line must consist
of three columns: name of the command, permissions, and mode. Read the
source for more info.
*/




/* Where are your mp3 files located? */
#define MP3DIR "/home/mp3"


/* this is a simple implementation which selects random
 * mp3 files by using find and $RANDOM to randomize 
 */
#define FIND_CMD "find " MP3DIR " -type f -name \"*.mp3\" \
	 -printf \"%h/%f\\n\" \
	| while read a ; do echo \"$RANDOM:$a\"; done \
	| sort -n | cut -f 2-99 -d':'"



#include <stdio.h>
#include <stdlib.h> /* EXIT_FAILURE/EXIT_SUCCESS */
#include <string.h> /* strcmp */

int main(int argc, char **argv)
{

	if (argc < 2)
		exit(EXIT_FAILURE);

	/* future (get new songs) */
	if (!strcmp(argv[1], "fut")) {
		unsigned nr = 10;
		FILE *pipe;
		char buf[8192];
		
		if (argc > 2)
			nr = atoi(argv[2]);
		if (!(pipe = popen(FIND_CMD, "r")))
			return -1;
		while (fgets(buf, 8192, pipe) && nr-- > 0)
			/* first number is score, always 42 here */
			printf("42 %s", buf);
			
		pclose(pipe);
		exit(EXIT_SUCCESS);

	}
	/* print database info on song */
	if (!strcmp(argv[1], "info")) {
		printf("No info available\n");
		exit(EXIT_SUCCESS);
	}
	/* server has sent this song, update database */ 
	if (!strcmp(argv[1], "us"))
		/* No need to update anything here */
		exit(EXIT_SUCCESS);
	/* print list of available streams (only one here) */
	if (!strcmp(argv[1], "streams")) {
		printf("all_songs\n");
		exit(EXIT_SUCCESS);
	}
        /* print list of available commands. first number specifies
         * permissions, second number specifies mode (read or
         * write). Omit "help" and "streams".
	 */
	if (!strcmp(argv[1], "help")) {
		if (argc <= 2)
			printf("fut\t1\t1\n"
				"info\t1\t1\n"
				"us\t1\t1\n"
			);
		else {
			printf ("One-line description\n");
			printf ("Usage\n");
			printf ("Description\n");
		}
		exit(EXIT_SUCCESS);
	}
	printf ("para_dbtool: Unknown command: %s\n", argv[1]);
	exit(EXIT_FAILURE);
}
